<template>
  <div class="table-day-column d-flex flex-column flex-grow-0">
    <div class="font-weight-bold px-2 py-2">{{ dateString }}</div>
    <div class="table-day-column-items d-flex flex-row flex-grow-0">
      <table-hour-column v-if="!skipzero" :latitude="latitude" :longitude="longitude" :date="date" :hour="0"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="1"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="2"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="3"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="4"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="5"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="6"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="7"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="8"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="9"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="10"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="11"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="12"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="13"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="14"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="15"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="16"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="17"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="18"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="19"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="20"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="21"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="22"/>
      <table-hour-column :latitude="latitude" :longitude="longitude" :date="date" :hour="23"/>
    </div>
  </div>
</template>

<script>
import moment from 'moment'
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'
import TableHourColumn from '@/workspace/components/query/TableHourColumn'

export default {
  name: 'tabledaycolumn',

  mixins: [
    WorkspaceGetter,
  ],

  props: {
    latitude: {
      type: Number,
      required: true
    },

    longitude: {
      type: Number,
      required: true
    },

    day: {
      type: Number,
      required: true,
    },

    skipzero: {
      type: Boolean,
      default: false
    },
  },

  computed: {
    referenceTime: {
      get() {
        return this.$store.getters.workspaceReferenceTime(this.workspaceId)
      },
    },

    query: {
      get() {
        return this.$store.getters.workspaceQuery(this.workspaceId)
      }
    },

    queryRequestCache: {
      get() {
        return this.$store.getters.workspaceQueryRequestCache(this.workspaceId)
      }
    },

    date: {
      get() {
        return moment.unix(this.referenceTime).add(this.day, 'days').unix()
      },
    },

    dateString: {
      get() {
        return moment.unix(this.date).format('YYYY-MM-DD')
      }
    },
  },

  components: {
    TableHourColumn,
  },
}
</script>
